#
# Conditional build:
%bcond_without	tests		# build without tests
#
%include	/usr/lib/rpm/macros.perl
Summary:	The flowd NetFlow collector daemon
Summary(pl.UTF-8):	flowd - demon zbierania danych NetFlow
Name:		flowd
Version:	0.9.1
Release:	13
License:	BSD
Group:		Applications/Networking
Source0:	http://www.mindrot.org/files/flowd/%{name}-%{version}.tar.gz
# Source0-md5:	a3d0512b5e6d9c7d9e749d9894376ea4
Patch0:		%{name}-username.patch
Patch1:		format-error.patch
URL:		http://www.mindrot.org/flowd.html
BuildRequires:	byacc
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	python-devel
BuildRequires:	python-modules
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.710
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts
Provides:	group(flowd)
Provides:	user(flowd)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is flowd, a NetFlow collector daemon intended to be small, fast
and secure.

It features some basic filtering to limit or tag the flows that are
recorded and is privilege separated, to limit security exposure from
bugs in flowd itself.

%description -l pl.UTF-8
Ten pakiet zawiera program flowd - demona zbierającego dane NetFlow,
mającego być małym, szybkim i bezpiecznym.

Obsługuje podstawowe filtrowanie w celu ograniczania lub znakowania
zapisywanych przepływów, ma rozdzielenie uprawnień w celu ograniczenia
wpływu własnych błedów na bezpieczeństwo.

%package -n perl-Flowd
Summary:	Perl API to access flowd logfiles
Summary(pl.UTF-8):	Perlowe API do dostępu do plików logów flowd
Group:		Development/Languages/Perl
Obsoletes:	flowd-perl

%description -n perl-Flowd
This is a Perl API to the binary flowd network flow log format and an
example reader application.

%description -n perl-Flowd -l pl.UTF-8
Ten pakiet zawiera API Perla dla binarnego formatu plików logów
przepływów sieciowych flowd oraz przykładowy program czytający.

%package -n python-flowd
Summary:	Python API to access flowd logfiles
Summary(pl.UTF-8):	Pythonowe API do dostępu do plików logów flowd
Group:		Applications/Networking
Obsoletes:	flowd-python

%description -n python-flowd
This is a Python API to the binary flowd network flow log format and
an example reader application.

%description -n python-flowd -l pl.UTF-8
Ten pakiet zawiera API Pythona dla binarnego formatu plików logów
przepływów sieciowych flowd oraz przykładowy program czytający.

%package tools
Summary:	Collection of example flowd tools
Summary(pl.UTF-8):	Zbiór przykładowych narzędzi dla flowd
Group:		Applications/Networking

%description tools
A collection of tools for use with flowd.

%description tools -l pl.UTF-8
Zbiór narzędzi do używania z flowd.

%package devel
Summary:	C API to access flowd logfiles
Summary(pl.UTF-8):	API C do dostępu do plików logów flowd
Group:		Development/Libraries

%description devel
This is a C API to the binary flowd network flow log format.

%description devel -l pl.UTF-8
Ten pakiet zawiera API C dla binarnego formatu plików logów przepływów
sieciowych flowd.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%configure
%{__make}

%py_build

cd Flowd-perl
%{__perl} Makefile.PL \
	INSTALLDIRS=vendor
%{__make}
%{?with_tests:%{__make} test}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# Misc stuff
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -p flowd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/flowd

# Perl module
%{__make} -C Flowd-perl pure_install \
	DESTDIR=$RPM_BUILD_ROOT

rm $RPM_BUILD_ROOT%{perl_vendorarch}/auto/Flowd/.packlist

# Python module
%py_install

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 198 flowd
%useradd -u 198 -d /usr/share/empty -s /bin/false -c "flowd user" -g flowd flowd

%post
/sbin/chkconfig --add flowd
%service flowd restart "flowd daemon"

%preun
if [ "$1" = "0" ]; then
	%service flowd stop
	/sbin/chkconfig --del flowd
fi

%postun
if [ "$1" = "0" ]; then
	%userremove flowd
	%groupremove flowd
fi

%files
%defattr(644,root,root,755)
%doc ChangeLog LICENSE README TODO
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/flowd.conf
%attr(754,root,root) /etc/rc.d/init.d/flowd
%attr(755,root,root) %{_bindir}/flowd-reader
%attr(755,root,root) %{_sbindir}/flowd
%{_mandir}/man5/flowd.conf.5*
%{_mandir}/man8/flowd.8*
%{_mandir}/man8/flowd-reader.8*

%files -n perl-Flowd
%defattr(644,root,root,755)
%doc reader.pl
%{perl_vendorarch}/Flowd.pm
%dir %{perl_vendorarch}/auto/Flowd
%attr(755,root,root) %{perl_vendorarch}/auto/Flowd/Flowd.so
%{_mandir}/man3/Flowd.3pm*

%files -n python-flowd
%defattr(644,root,root,755)
%doc reader.py
%attr(755,root,root) %{py_sitedir}/flowd.so
%if "%{py_ver}" > "2.4"
%{py_sitedir}/flowd-*.egg-info
%endif

%files tools
%defattr(644,root,root,755)
%doc tools/*

%files devel
%defattr(644,root,root,755)
%{_includedir}/flowd
%{_libdir}/libflowd.a
%changelog
* Thu Aug 30 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/flowd.git;a=log;h=master

* Thu Aug 30 2018 Jan Rękorajski <baggins@pld-linux.org> 3e40d0a
- rebuild with perl 5.28.0
- release 13 (by relup.sh)

* Sun Jun 11 2017 Jan Rękorajski <baggins@pld-linux.org> 232ccc4
- perl req/prov fix
- release 12 (by relup.sh)

* Sun Jun 11 2017 Jan Rękorajski <baggins@pld-linux.org> 6b43c93
- rebuild with perl 5.26
- release 11 (by relup.sh)

* Sun Oct 30 2016 Jan Rękorajski <baggins@pld-linux.org> 675c8bc
- rebuild with perl 5.24.0
- release 10 (by relup.sh)

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> 54f86df
- release 9 (by relup.sh)

* Mon Nov 30 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 4e88d84
- release 8 (by relup.sh)

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 35797f6
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 8019073
- release 7 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> a087333
- automatic change: use py_build/py_install macros

* Sun Sep 14 2014 Jan Rękorajski <baggins@pld-linux.org> 251d426
- release 6 (by relup.sh)

* Sun Sep 14 2014 Jan Rękorajski <baggins@pld-linux.org> 4a84887
- removed zero-sized .bs file

* Sun Jun 09 2013 Jan Rękorajski <baggins@pld-linux.org> 2300418
- rel 5

* Sun Jun 09 2013 Jan Rękorajski <baggins@pld-linux.org> 7174eac
- fix format string error

* Sat Jun 08 2013 Jan Rękorajski <baggins@pld-linux.org> 680a73e
- rebuild with perl 5.18.0
- release 4 (by relup.sh)

* Sun Jan 30 2011 sparky <sparky@pld-linux.org> 7f4dbfa
- BR: python-modules, rpm-pythonprov

* Wed Aug 11 2010 zbyniu <zbyniu@pld-linux.org> 361839b
- proper O: for python-flowd, rel 3

* Fri Jul 09 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> eef2794
- release 2

* Sun Jun 06 2010 Elan Ruusamäe <glen@pld-linux.org> 94149db
- rename binding packages, finish python files, cleanups; rel 1

* Wed Sep 24 2008 pawelz <pawelz@pld-linux.org> f737cb7
- added patch0

* Wed Sep 24 2008 pawelz <pawelz@pld-linux.org> 9570152
- better name for privsep user

